

-- | Copyright  : Will Thompson and Iñaki García Etxebarria
-- License    : LGPL-2.1
-- Maintainer : Iñaki García Etxebarria

#if (MIN_VERSION_haskell_gi_overloading(1,0,0) && !defined(__HADDOCK_VERSION__))
#define ENABLE_OVERLOADING
#endif

module GI.HarfBuzz.Enums
    ( 

 -- * Enumerations


-- ** BufferClusterLevelT #enum:BufferClusterLevelT#

    BufferClusterLevelT(..)                 ,


-- ** BufferContentTypeT #enum:BufferContentTypeT#

    BufferContentTypeT(..)                  ,


-- ** DirectionT #enum:DirectionT#

    DirectionT(..)                          ,


-- ** MemoryModeT #enum:MemoryModeT#

    MemoryModeT(..)                         ,


-- ** OtLayoutGlyphClassT #enum:OtLayoutGlyphClassT#

    OtLayoutGlyphClassT(..)                 ,


-- ** OtMathConstantT #enum:OtMathConstantT#

    OtMathConstantT(..)                     ,


-- ** OtMathKernT #enum:OtMathKernT#

    OtMathKernT(..)                         ,


-- ** OtNameIdPredefinedT #enum:OtNameIdPredefinedT#

    OtNameIdPredefinedT(..)                 ,


-- ** PaintCompositeModeT #enum:PaintCompositeModeT#

    PaintCompositeModeT(..)                 ,


-- ** PaintExtendT #enum:PaintExtendT#

    PaintExtendT(..)                        ,


-- ** UnicodeCombiningClassT #enum:UnicodeCombiningClassT#

    UnicodeCombiningClassT(..)              ,


-- ** UnicodeGeneralCategoryT #enum:UnicodeGeneralCategoryT#

    UnicodeGeneralCategoryT(..)             ,




    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.BasicTypes as B.Types
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GArray as B.GArray
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GHashTable as B.GHT
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.GI.Base.Signals as B.Signals
import qualified Control.Monad.IO.Class as MIO
import qualified Data.Coerce as Coerce
import qualified Data.Text as T
import qualified Data.Kind as DK
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL
import qualified GHC.Records as R
import qualified Data.Word as DW
import qualified Data.Int as DI
import qualified System.Posix.Types as SPT
import qualified Foreign.C.Types as FCT

-- Workaround for https://gitlab.haskell.org/ghc/ghc/-/issues/23392
#if MIN_VERSION_base(4,18,0)

#else

#endif

-- Enum unicode_general_category_t
-- | Data type for the \"General_Category\" (gc) property from
-- the Unicode Character Database.
data UnicodeGeneralCategoryT = 
      UnicodeGeneralCategoryTControl
    -- ^ [Cc]
    | UnicodeGeneralCategoryTFormat
    -- ^ [Cf]
    | UnicodeGeneralCategoryTUnassigned
    -- ^ [Cn]
    | UnicodeGeneralCategoryTPrivateUse
    -- ^ [Co]
    | UnicodeGeneralCategoryTSurrogate
    -- ^ [Cs]
    | UnicodeGeneralCategoryTLowercaseLetter
    -- ^ [Ll]
    | UnicodeGeneralCategoryTModifierLetter
    -- ^ [Lm]
    | UnicodeGeneralCategoryTOtherLetter
    -- ^ [Lo]
    | UnicodeGeneralCategoryTTitlecaseLetter
    -- ^ [Lt]
    | UnicodeGeneralCategoryTUppercaseLetter
    -- ^ [Lu]
    | UnicodeGeneralCategoryTSpacingMark
    -- ^ [Mc]
    | UnicodeGeneralCategoryTEnclosingMark
    -- ^ [Me]
    | UnicodeGeneralCategoryTNonSpacingMark
    -- ^ [Mn]
    | UnicodeGeneralCategoryTDecimalNumber
    -- ^ [Nd]
    | UnicodeGeneralCategoryTLetterNumber
    -- ^ [Nl]
    | UnicodeGeneralCategoryTOtherNumber
    -- ^ [No]
    | UnicodeGeneralCategoryTConnectPunctuation
    -- ^ [Pc]
    | UnicodeGeneralCategoryTDashPunctuation
    -- ^ [Pd]
    | UnicodeGeneralCategoryTClosePunctuation
    -- ^ [Pe]
    | UnicodeGeneralCategoryTFinalPunctuation
    -- ^ [Pf]
    | UnicodeGeneralCategoryTInitialPunctuation
    -- ^ [Pi]
    | UnicodeGeneralCategoryTOtherPunctuation
    -- ^ [Po]
    | UnicodeGeneralCategoryTOpenPunctuation
    -- ^ [Ps]
    | UnicodeGeneralCategoryTCurrencySymbol
    -- ^ [Sc]
    | UnicodeGeneralCategoryTModifierSymbol
    -- ^ [Sk]
    | UnicodeGeneralCategoryTMathSymbol
    -- ^ [Sm]
    | UnicodeGeneralCategoryTOtherSymbol
    -- ^ [So]
    | UnicodeGeneralCategoryTLineSeparator
    -- ^ [Zl]
    | UnicodeGeneralCategoryTParagraphSeparator
    -- ^ [Zp]
    | UnicodeGeneralCategoryTSpaceSeparator
    -- ^ [Zs]
    | AnotherUnicodeGeneralCategoryT Int
    -- ^ Catch-all for unknown values
    deriving (Show, Eq)

instance P.Enum UnicodeGeneralCategoryT where
    fromEnum UnicodeGeneralCategoryTControl = 0
    fromEnum UnicodeGeneralCategoryTFormat = 1
    fromEnum UnicodeGeneralCategoryTUnassigned = 2
    fromEnum UnicodeGeneralCategoryTPrivateUse = 3
    fromEnum UnicodeGeneralCategoryTSurrogate = 4
    fromEnum UnicodeGeneralCategoryTLowercaseLetter = 5
    fromEnum UnicodeGeneralCategoryTModifierLetter = 6
    fromEnum UnicodeGeneralCategoryTOtherLetter = 7
    fromEnum UnicodeGeneralCategoryTTitlecaseLetter = 8
    fromEnum UnicodeGeneralCategoryTUppercaseLetter = 9
    fromEnum UnicodeGeneralCategoryTSpacingMark = 10
    fromEnum UnicodeGeneralCategoryTEnclosingMark = 11
    fromEnum UnicodeGeneralCategoryTNonSpacingMark = 12
    fromEnum UnicodeGeneralCategoryTDecimalNumber = 13
    fromEnum UnicodeGeneralCategoryTLetterNumber = 14
    fromEnum UnicodeGeneralCategoryTOtherNumber = 15
    fromEnum UnicodeGeneralCategoryTConnectPunctuation = 16
    fromEnum UnicodeGeneralCategoryTDashPunctuation = 17
    fromEnum UnicodeGeneralCategoryTClosePunctuation = 18
    fromEnum UnicodeGeneralCategoryTFinalPunctuation = 19
    fromEnum UnicodeGeneralCategoryTInitialPunctuation = 20
    fromEnum UnicodeGeneralCategoryTOtherPunctuation = 21
    fromEnum UnicodeGeneralCategoryTOpenPunctuation = 22
    fromEnum UnicodeGeneralCategoryTCurrencySymbol = 23
    fromEnum UnicodeGeneralCategoryTModifierSymbol = 24
    fromEnum UnicodeGeneralCategoryTMathSymbol = 25
    fromEnum UnicodeGeneralCategoryTOtherSymbol = 26
    fromEnum UnicodeGeneralCategoryTLineSeparator = 27
    fromEnum UnicodeGeneralCategoryTParagraphSeparator = 28
    fromEnum UnicodeGeneralCategoryTSpaceSeparator = 29
    fromEnum (AnotherUnicodeGeneralCategoryT k) = k

    toEnum 0 = UnicodeGeneralCategoryTControl
    toEnum 1 = UnicodeGeneralCategoryTFormat
    toEnum 2 = UnicodeGeneralCategoryTUnassigned
    toEnum 3 = UnicodeGeneralCategoryTPrivateUse
    toEnum 4 = UnicodeGeneralCategoryTSurrogate
    toEnum 5 = UnicodeGeneralCategoryTLowercaseLetter
    toEnum 6 = UnicodeGeneralCategoryTModifierLetter
    toEnum 7 = UnicodeGeneralCategoryTOtherLetter
    toEnum 8 = UnicodeGeneralCategoryTTitlecaseLetter
    toEnum 9 = UnicodeGeneralCategoryTUppercaseLetter
    toEnum 10 = UnicodeGeneralCategoryTSpacingMark
    toEnum 11 = UnicodeGeneralCategoryTEnclosingMark
    toEnum 12 = UnicodeGeneralCategoryTNonSpacingMark
    toEnum 13 = UnicodeGeneralCategoryTDecimalNumber
    toEnum 14 = UnicodeGeneralCategoryTLetterNumber
    toEnum 15 = UnicodeGeneralCategoryTOtherNumber
    toEnum 16 = UnicodeGeneralCategoryTConnectPunctuation
    toEnum 17 = UnicodeGeneralCategoryTDashPunctuation
    toEnum 18 = UnicodeGeneralCategoryTClosePunctuation
    toEnum 19 = UnicodeGeneralCategoryTFinalPunctuation
    toEnum 20 = UnicodeGeneralCategoryTInitialPunctuation
    toEnum 21 = UnicodeGeneralCategoryTOtherPunctuation
    toEnum 22 = UnicodeGeneralCategoryTOpenPunctuation
    toEnum 23 = UnicodeGeneralCategoryTCurrencySymbol
    toEnum 24 = UnicodeGeneralCategoryTModifierSymbol
    toEnum 25 = UnicodeGeneralCategoryTMathSymbol
    toEnum 26 = UnicodeGeneralCategoryTOtherSymbol
    toEnum 27 = UnicodeGeneralCategoryTLineSeparator
    toEnum 28 = UnicodeGeneralCategoryTParagraphSeparator
    toEnum 29 = UnicodeGeneralCategoryTSpaceSeparator
    toEnum k = AnotherUnicodeGeneralCategoryT k

instance P.Ord UnicodeGeneralCategoryT where
    compare a b = P.compare (P.fromEnum a) (P.fromEnum b)

-- Enum unicode_combining_class_t
-- | Data type for the Canonical_Combining_Class (ccc) property
-- from the Unicode Character Database.
-- 
-- \<note>Note: newer versions of Unicode may add new values.
-- Client programs should be ready to handle any value in the 0..254 range
-- being returned from 'GI.HarfBuzz.Functions.unicodeCombiningClass'.\<\/note>
data UnicodeCombiningClassT = 
      UnicodeCombiningClassTNotReordered
    -- ^ Spacing and enclosing marks; also many vowel and consonant signs, even if nonspacing
    | UnicodeCombiningClassTOverlay
    -- ^ Marks which overlay a base letter or symbol
    | UnicodeCombiningClassTNukta
    -- ^ Diacritic nukta marks in Brahmi-derived scripts
    | UnicodeCombiningClassTKanaVoicing
    -- ^ Hiragana\/Katakana voicing marks
    | UnicodeCombiningClassTVirama
    -- ^ Viramas
    | UnicodeCombiningClassTCcc10
    -- ^ [Hebrew]
    | UnicodeCombiningClassTCcc11
    -- ^ [Hebrew]
    | UnicodeCombiningClassTCcc12
    -- ^ [Hebrew]
    | UnicodeCombiningClassTCcc13
    -- ^ [Hebrew]
    | UnicodeCombiningClassTCcc14
    -- ^ [Hebrew]
    | UnicodeCombiningClassTCcc15
    -- ^ [Hebrew]
    | UnicodeCombiningClassTCcc16
    -- ^ [Hebrew]
    | UnicodeCombiningClassTCcc17
    -- ^ [Hebrew]
    | UnicodeCombiningClassTCcc18
    -- ^ [Hebrew]
    | UnicodeCombiningClassTCcc19
    -- ^ [Hebrew]
    | UnicodeCombiningClassTCcc20
    -- ^ [Hebrew]
    | UnicodeCombiningClassTCcc21
    -- ^ [Hebrew]
    | UnicodeCombiningClassTCcc22
    -- ^ [Hebrew]
    | UnicodeCombiningClassTCcc23
    -- ^ [Hebrew]
    | UnicodeCombiningClassTCcc24
    -- ^ [Hebrew]
    | UnicodeCombiningClassTCcc25
    -- ^ [Hebrew]
    | UnicodeCombiningClassTCcc26
    -- ^ [Hebrew]
    | UnicodeCombiningClassTCcc27
    -- ^ [Arabic]
    | UnicodeCombiningClassTCcc28
    -- ^ [Arabic]
    | UnicodeCombiningClassTCcc29
    -- ^ [Arabic]
    | UnicodeCombiningClassTCcc30
    -- ^ [Arabic]
    | UnicodeCombiningClassTCcc31
    -- ^ [Arabic]
    | UnicodeCombiningClassTCcc32
    -- ^ [Arabic]
    | UnicodeCombiningClassTCcc33
    -- ^ [Arabic]
    | UnicodeCombiningClassTCcc34
    -- ^ [Arabic]
    | UnicodeCombiningClassTCcc35
    -- ^ [Arabic]
    | UnicodeCombiningClassTCcc36
    -- ^ [Syriac]
    | UnicodeCombiningClassTCcc84
    -- ^ [Telugu]
    | UnicodeCombiningClassTCcc91
    -- ^ [Telugu]
    | UnicodeCombiningClassTCcc103
    -- ^ [Thai]
    | UnicodeCombiningClassTCcc107
    -- ^ [Thai]
    | UnicodeCombiningClassTCcc118
    -- ^ [Lao]
    | UnicodeCombiningClassTCcc122
    -- ^ [Lao]
    | UnicodeCombiningClassTCcc129
    -- ^ [Tibetan]
    | UnicodeCombiningClassTCcc130
    -- ^ [Tibetan]
    | UnicodeCombiningClassTCcc132
    -- ^ [Tibetan] Since: 7.2.0
    | UnicodeCombiningClassTAttachedBelowLeft
    -- ^ Marks attached at the bottom left
    | UnicodeCombiningClassTAttachedBelow
    -- ^ Marks attached directly below
    | UnicodeCombiningClassTAttachedAbove
    -- ^ Marks attached directly above
    | UnicodeCombiningClassTAttachedAboveRight
    -- ^ Marks attached at the top right
    | UnicodeCombiningClassTBelowLeft
    -- ^ Distinct marks at the bottom left
    | UnicodeCombiningClassTBelow
    -- ^ Distinct marks directly below
    | UnicodeCombiningClassTBelowRight
    -- ^ Distinct marks at the bottom right
    | UnicodeCombiningClassTLeft
    -- ^ Distinct marks to the left
    | UnicodeCombiningClassTRight
    -- ^ Distinct marks to the right
    | UnicodeCombiningClassTAboveLeft
    -- ^ Distinct marks at the top left
    | UnicodeCombiningClassTAbove
    -- ^ Distinct marks directly above
    | UnicodeCombiningClassTAboveRight
    -- ^ Distinct marks at the top right
    | UnicodeCombiningClassTDoubleBelow
    -- ^ Distinct marks subtending two bases
    | UnicodeCombiningClassTDoubleAbove
    -- ^ Distinct marks extending above two bases
    | UnicodeCombiningClassTIotaSubscript
    -- ^ Greek iota subscript only
    | UnicodeCombiningClassTInvalid
    -- ^ Invalid combining class
    | AnotherUnicodeCombiningClassT Int
    -- ^ Catch-all for unknown values
    deriving (Show, Eq)

instance P.Enum UnicodeCombiningClassT where
    fromEnum UnicodeCombiningClassTNotReordered = 0
    fromEnum UnicodeCombiningClassTOverlay = 1
    fromEnum UnicodeCombiningClassTNukta = 7
    fromEnum UnicodeCombiningClassTKanaVoicing = 8
    fromEnum UnicodeCombiningClassTVirama = 9
    fromEnum UnicodeCombiningClassTCcc10 = 10
    fromEnum UnicodeCombiningClassTCcc11 = 11
    fromEnum UnicodeCombiningClassTCcc12 = 12
    fromEnum UnicodeCombiningClassTCcc13 = 13
    fromEnum UnicodeCombiningClassTCcc14 = 14
    fromEnum UnicodeCombiningClassTCcc15 = 15
    fromEnum UnicodeCombiningClassTCcc16 = 16
    fromEnum UnicodeCombiningClassTCcc17 = 17
    fromEnum UnicodeCombiningClassTCcc18 = 18
    fromEnum UnicodeCombiningClassTCcc19 = 19
    fromEnum UnicodeCombiningClassTCcc20 = 20
    fromEnum UnicodeCombiningClassTCcc21 = 21
    fromEnum UnicodeCombiningClassTCcc22 = 22
    fromEnum UnicodeCombiningClassTCcc23 = 23
    fromEnum UnicodeCombiningClassTCcc24 = 24
    fromEnum UnicodeCombiningClassTCcc25 = 25
    fromEnum UnicodeCombiningClassTCcc26 = 26
    fromEnum UnicodeCombiningClassTCcc27 = 27
    fromEnum UnicodeCombiningClassTCcc28 = 28
    fromEnum UnicodeCombiningClassTCcc29 = 29
    fromEnum UnicodeCombiningClassTCcc30 = 30
    fromEnum UnicodeCombiningClassTCcc31 = 31
    fromEnum UnicodeCombiningClassTCcc32 = 32
    fromEnum UnicodeCombiningClassTCcc33 = 33
    fromEnum UnicodeCombiningClassTCcc34 = 34
    fromEnum UnicodeCombiningClassTCcc35 = 35
    fromEnum UnicodeCombiningClassTCcc36 = 36
    fromEnum UnicodeCombiningClassTCcc84 = 84
    fromEnum UnicodeCombiningClassTCcc91 = 91
    fromEnum UnicodeCombiningClassTCcc103 = 103
    fromEnum UnicodeCombiningClassTCcc107 = 107
    fromEnum UnicodeCombiningClassTCcc118 = 118
    fromEnum UnicodeCombiningClassTCcc122 = 122
    fromEnum UnicodeCombiningClassTCcc129 = 129
    fromEnum UnicodeCombiningClassTCcc130 = 130
    fromEnum UnicodeCombiningClassTCcc132 = 132
    fromEnum UnicodeCombiningClassTAttachedBelowLeft = 200
    fromEnum UnicodeCombiningClassTAttachedBelow = 202
    fromEnum UnicodeCombiningClassTAttachedAbove = 214
    fromEnum UnicodeCombiningClassTAttachedAboveRight = 216
    fromEnum UnicodeCombiningClassTBelowLeft = 218
    fromEnum UnicodeCombiningClassTBelow = 220
    fromEnum UnicodeCombiningClassTBelowRight = 222
    fromEnum UnicodeCombiningClassTLeft = 224
    fromEnum UnicodeCombiningClassTRight = 226
    fromEnum UnicodeCombiningClassTAboveLeft = 228
    fromEnum UnicodeCombiningClassTAbove = 230
    fromEnum UnicodeCombiningClassTAboveRight = 232
    fromEnum UnicodeCombiningClassTDoubleBelow = 233
    fromEnum UnicodeCombiningClassTDoubleAbove = 234
    fromEnum UnicodeCombiningClassTIotaSubscript = 240
    fromEnum UnicodeCombiningClassTInvalid = 255
    fromEnum (AnotherUnicodeCombiningClassT k) = k

    toEnum 0 = UnicodeCombiningClassTNotReordered
    toEnum 1 = UnicodeCombiningClassTOverlay
    toEnum 7 = UnicodeCombiningClassTNukta
    toEnum 8 = UnicodeCombiningClassTKanaVoicing
    toEnum 9 = UnicodeCombiningClassTVirama
    toEnum 10 = UnicodeCombiningClassTCcc10
    toEnum 11 = UnicodeCombiningClassTCcc11
    toEnum 12 = UnicodeCombiningClassTCcc12
    toEnum 13 = UnicodeCombiningClassTCcc13
    toEnum 14 = UnicodeCombiningClassTCcc14
    toEnum 15 = UnicodeCombiningClassTCcc15
    toEnum 16 = UnicodeCombiningClassTCcc16
    toEnum 17 = UnicodeCombiningClassTCcc17
    toEnum 18 = UnicodeCombiningClassTCcc18
    toEnum 19 = UnicodeCombiningClassTCcc19
    toEnum 20 = UnicodeCombiningClassTCcc20
    toEnum 21 = UnicodeCombiningClassTCcc21
    toEnum 22 = UnicodeCombiningClassTCcc22
    toEnum 23 = UnicodeCombiningClassTCcc23
    toEnum 24 = UnicodeCombiningClassTCcc24
    toEnum 25 = UnicodeCombiningClassTCcc25
    toEnum 26 = UnicodeCombiningClassTCcc26
    toEnum 27 = UnicodeCombiningClassTCcc27
    toEnum 28 = UnicodeCombiningClassTCcc28
    toEnum 29 = UnicodeCombiningClassTCcc29
    toEnum 30 = UnicodeCombiningClassTCcc30
    toEnum 31 = UnicodeCombiningClassTCcc31
    toEnum 32 = UnicodeCombiningClassTCcc32
    toEnum 33 = UnicodeCombiningClassTCcc33
    toEnum 34 = UnicodeCombiningClassTCcc34
    toEnum 35 = UnicodeCombiningClassTCcc35
    toEnum 36 = UnicodeCombiningClassTCcc36
    toEnum 84 = UnicodeCombiningClassTCcc84
    toEnum 91 = UnicodeCombiningClassTCcc91
    toEnum 103 = UnicodeCombiningClassTCcc103
    toEnum 107 = UnicodeCombiningClassTCcc107
    toEnum 118 = UnicodeCombiningClassTCcc118
    toEnum 122 = UnicodeCombiningClassTCcc122
    toEnum 129 = UnicodeCombiningClassTCcc129
    toEnum 130 = UnicodeCombiningClassTCcc130
    toEnum 132 = UnicodeCombiningClassTCcc132
    toEnum 200 = UnicodeCombiningClassTAttachedBelowLeft
    toEnum 202 = UnicodeCombiningClassTAttachedBelow
    toEnum 214 = UnicodeCombiningClassTAttachedAbove
    toEnum 216 = UnicodeCombiningClassTAttachedAboveRight
    toEnum 218 = UnicodeCombiningClassTBelowLeft
    toEnum 220 = UnicodeCombiningClassTBelow
    toEnum 222 = UnicodeCombiningClassTBelowRight
    toEnum 224 = UnicodeCombiningClassTLeft
    toEnum 226 = UnicodeCombiningClassTRight
    toEnum 228 = UnicodeCombiningClassTAboveLeft
    toEnum 230 = UnicodeCombiningClassTAbove
    toEnum 232 = UnicodeCombiningClassTAboveRight
    toEnum 233 = UnicodeCombiningClassTDoubleBelow
    toEnum 234 = UnicodeCombiningClassTDoubleAbove
    toEnum 240 = UnicodeCombiningClassTIotaSubscript
    toEnum 255 = UnicodeCombiningClassTInvalid
    toEnum k = AnotherUnicodeCombiningClassT k

instance P.Ord UnicodeCombiningClassT where
    compare a b = P.compare (P.fromEnum a) (P.fromEnum b)

-- Enum paint_extend_t
-- | The values of this enumeration determine how color values
-- outside the minimum and maximum defined offset on a t'GI.HarfBuzz.Structs.ColorLineT.ColorLineT'
-- are determined.
-- 
-- See the OpenType spec <https://learn.microsoft.com/en-us/typography/opentype/spec/colr COLR>
-- section for details.
-- 
-- /Since: 7.0.0/
data PaintExtendT = 
      PaintExtendTPad
    -- ^ Outside the defined interval,
    --   the color of the closest color stop is used.
    | PaintExtendTRepeat
    -- ^ The color line is repeated over
    --   repeated multiples of the defined interval
    | PaintExtendTReflect
    -- ^ The color line is repeated over
    --      repeated intervals, as for the repeat mode.
    --      However, in each repeated interval, the ordering of
    --      color stops is the reverse of the adjacent interval.
    | AnotherPaintExtendT Int
    -- ^ Catch-all for unknown values
    deriving (Show, Eq)

instance P.Enum PaintExtendT where
    fromEnum PaintExtendTPad = 0
    fromEnum PaintExtendTRepeat = 1
    fromEnum PaintExtendTReflect = 2
    fromEnum (AnotherPaintExtendT k) = k

    toEnum 0 = PaintExtendTPad
    toEnum 1 = PaintExtendTRepeat
    toEnum 2 = PaintExtendTReflect
    toEnum k = AnotherPaintExtendT k

instance P.Ord PaintExtendT where
    compare a b = P.compare (P.fromEnum a) (P.fromEnum b)

-- Enum paint_composite_mode_t
-- | The values of this enumeration describe the compositing modes
-- that can be used when combining temporary redirected drawing
-- with the backdrop.
-- 
-- See the OpenType spec <https://learn.microsoft.com/en-us/typography/opentype/spec/colr COLR>
-- section for details.
-- 
-- /Since: 7.0.0/
data PaintCompositeModeT = 
      PaintCompositeModeTClear
    -- ^ clear destination layer (bounded)
    | PaintCompositeModeTSrc
    -- ^ replace destination layer (bounded)
    | PaintCompositeModeTDest
    -- ^ ignore the source
    | PaintCompositeModeTSrcOver
    -- ^ draw source layer on top of destination layer
    -- (bounded)
    | PaintCompositeModeTDestOver
    -- ^ draw destination on top of source
    | PaintCompositeModeTSrcIn
    -- ^ draw source where there was destination content
    -- (unbounded)
    | PaintCompositeModeTDestIn
    -- ^ leave destination only where there was
    -- source content (unbounded)
    | PaintCompositeModeTSrcOut
    -- ^ draw source where there was no destination
    -- content (unbounded)
    | PaintCompositeModeTDestOut
    -- ^ leave destination only where there was no
    -- source content
    | PaintCompositeModeTSrcAtop
    -- ^ draw source on top of destination content and
    -- only there
    | PaintCompositeModeTDestAtop
    -- ^ leave destination on top of source content
    -- and only there (unbounded)
    | PaintCompositeModeTXor
    -- ^ source and destination are shown where there is only
    -- one of them
    | PaintCompositeModeTPlus
    -- ^ source and destination layers are accumulated
    | PaintCompositeModeTScreen
    -- ^ source and destination are complemented and
    -- multiplied. This causes the result to be at least as light as the lighter
    -- inputs.
    | PaintCompositeModeTOverlay
    -- ^ multiplies or screens, depending on the
    -- lightness of the destination color.
    | PaintCompositeModeTDarken
    -- ^ replaces the destination with the source if it
    -- is darker, otherwise keeps the source.
    | PaintCompositeModeTLighten
    -- ^ replaces the destination with the source if it
    -- is lighter, otherwise keeps the source.
    | PaintCompositeModeTColorDodge
    -- ^ brightens the destination color to reflect
    -- the source color.
    | PaintCompositeModeTColorBurn
    -- ^ darkens the destination color to reflect
    -- the source color.
    | PaintCompositeModeTHardLight
    -- ^ Multiplies or screens, dependent on source
    -- color.
    | PaintCompositeModeTSoftLight
    -- ^ Darkens or lightens, dependent on source
    -- color.
    | PaintCompositeModeTDifference
    -- ^ Takes the difference of the source and
    -- destination color.
    | PaintCompositeModeTExclusion
    -- ^ Produces an effect similar to difference, but
    -- with lower contrast.
    | PaintCompositeModeTMultiply
    -- ^ source and destination layers are multiplied.
    -- This causes the result to be at least as dark as the darker inputs.
    | PaintCompositeModeTHslHue
    -- ^ Creates a color with the hue of the source
    -- and the saturation and luminosity of the target.
    | PaintCompositeModeTHslSaturation
    -- ^ Creates a color with the saturation
    -- of the source and the hue and luminosity of the target. Painting with
    -- this mode onto a gray area produces no change.
    | PaintCompositeModeTHslColor
    -- ^ Creates a color with the hue and saturation
    -- of the source and the luminosity of the target. This preserves the gray
    -- levels of the target and is useful for coloring monochrome images or
    -- tinting color images.
    | PaintCompositeModeTHslLuminosity
    -- ^ Creates a color with the luminosity of
    -- the source and the hue and saturation of the target. This produces an
    -- inverse effect to /@hBPAINTCOMPOSITEMODEHSLCOLOR@/.
    | AnotherPaintCompositeModeT Int
    -- ^ Catch-all for unknown values
    deriving (Show, Eq)

instance P.Enum PaintCompositeModeT where
    fromEnum PaintCompositeModeTClear = 0
    fromEnum PaintCompositeModeTSrc = 1
    fromEnum PaintCompositeModeTDest = 2
    fromEnum PaintCompositeModeTSrcOver = 3
    fromEnum PaintCompositeModeTDestOver = 4
    fromEnum PaintCompositeModeTSrcIn = 5
    fromEnum PaintCompositeModeTDestIn = 6
    fromEnum PaintCompositeModeTSrcOut = 7
    fromEnum PaintCompositeModeTDestOut = 8
    fromEnum PaintCompositeModeTSrcAtop = 9
    fromEnum PaintCompositeModeTDestAtop = 10
    fromEnum PaintCompositeModeTXor = 11
    fromEnum PaintCompositeModeTPlus = 12
    fromEnum PaintCompositeModeTScreen = 13
    fromEnum PaintCompositeModeTOverlay = 14
    fromEnum PaintCompositeModeTDarken = 15
    fromEnum PaintCompositeModeTLighten = 16
    fromEnum PaintCompositeModeTColorDodge = 17
    fromEnum PaintCompositeModeTColorBurn = 18
    fromEnum PaintCompositeModeTHardLight = 19
    fromEnum PaintCompositeModeTSoftLight = 20
    fromEnum PaintCompositeModeTDifference = 21
    fromEnum PaintCompositeModeTExclusion = 22
    fromEnum PaintCompositeModeTMultiply = 23
    fromEnum PaintCompositeModeTHslHue = 24
    fromEnum PaintCompositeModeTHslSaturation = 25
    fromEnum PaintCompositeModeTHslColor = 26
    fromEnum PaintCompositeModeTHslLuminosity = 27
    fromEnum (AnotherPaintCompositeModeT k) = k

    toEnum 0 = PaintCompositeModeTClear
    toEnum 1 = PaintCompositeModeTSrc
    toEnum 2 = PaintCompositeModeTDest
    toEnum 3 = PaintCompositeModeTSrcOver
    toEnum 4 = PaintCompositeModeTDestOver
    toEnum 5 = PaintCompositeModeTSrcIn
    toEnum 6 = PaintCompositeModeTDestIn
    toEnum 7 = PaintCompositeModeTSrcOut
    toEnum 8 = PaintCompositeModeTDestOut
    toEnum 9 = PaintCompositeModeTSrcAtop
    toEnum 10 = PaintCompositeModeTDestAtop
    toEnum 11 = PaintCompositeModeTXor
    toEnum 12 = PaintCompositeModeTPlus
    toEnum 13 = PaintCompositeModeTScreen
    toEnum 14 = PaintCompositeModeTOverlay
    toEnum 15 = PaintCompositeModeTDarken
    toEnum 16 = PaintCompositeModeTLighten
    toEnum 17 = PaintCompositeModeTColorDodge
    toEnum 18 = PaintCompositeModeTColorBurn
    toEnum 19 = PaintCompositeModeTHardLight
    toEnum 20 = PaintCompositeModeTSoftLight
    toEnum 21 = PaintCompositeModeTDifference
    toEnum 22 = PaintCompositeModeTExclusion
    toEnum 23 = PaintCompositeModeTMultiply
    toEnum 24 = PaintCompositeModeTHslHue
    toEnum 25 = PaintCompositeModeTHslSaturation
    toEnum 26 = PaintCompositeModeTHslColor
    toEnum 27 = PaintCompositeModeTHslLuminosity
    toEnum k = AnotherPaintCompositeModeT k

instance P.Ord PaintCompositeModeT where
    compare a b = P.compare (P.fromEnum a) (P.fromEnum b)

-- Enum ot_name_id_predefined_t
-- | An enum type representing the pre-defined name IDs.
-- 
-- For more information on these fields, see the
-- <https://docs.microsoft.com/en-us/typography/opentype/spec/name#name-ids OpenType spec>.
-- 
-- /Since: 7.0.0/
data OtNameIdPredefinedT = 
      OtNameIdPredefinedTCopyright
    -- ^ Copyright notice
    | OtNameIdPredefinedTFontFamily
    -- ^ Font Family name
    | OtNameIdPredefinedTFontSubfamily
    -- ^ Font Subfamily name
    | OtNameIdPredefinedTUniqueId
    -- ^ Unique font identifier
    | OtNameIdPredefinedTFullName
    -- ^ Full font name that reflects
    -- all family and relevant subfamily descriptors
    | OtNameIdPredefinedTVersionString
    -- ^ Version string
    | OtNameIdPredefinedTPostscriptName
    -- ^ PostScript name for the font
    | OtNameIdPredefinedTTrademark
    -- ^ Trademark
    | OtNameIdPredefinedTManufacturer
    -- ^ Manufacturer Name
    | OtNameIdPredefinedTDesigner
    -- ^ Designer
    | OtNameIdPredefinedTDescription
    -- ^ Description
    | OtNameIdPredefinedTVendorUrl
    -- ^ URL of font vendor
    | OtNameIdPredefinedTDesignerUrl
    -- ^ URL of typeface designer
    | OtNameIdPredefinedTLicense
    -- ^ License Description
    | OtNameIdPredefinedTLicenseUrl
    -- ^ URL where additional licensing
    -- information can be found
    | OtNameIdPredefinedTTypographicFamily
    -- ^ Typographic Family name
    | OtNameIdPredefinedTTypographicSubfamily
    -- ^ Typographic Subfamily name
    | OtNameIdPredefinedTMacFullName
    -- ^ Compatible Full Name for MacOS
    | OtNameIdPredefinedTSampleText
    -- ^ Sample text
    | OtNameIdPredefinedTCidFindfontName
    -- ^ PostScript CID findfont name
    | OtNameIdPredefinedTWwsFamily
    -- ^ WWS Family Name
    | OtNameIdPredefinedTWwsSubfamily
    -- ^ WWS Subfamily Name
    | OtNameIdPredefinedTLightBackground
    -- ^ Light Background Palette
    | OtNameIdPredefinedTDarkBackground
    -- ^ Dark Background Palette
    | OtNameIdPredefinedTVariationsPsPrefix
    -- ^ Variations PostScript Name Prefix
    | OtNameIdPredefinedTInvalid
    -- ^ Value to represent a nonexistent name ID.
    | AnotherOtNameIdPredefinedT Int
    -- ^ Catch-all for unknown values
    deriving (Show, Eq)

instance P.Enum OtNameIdPredefinedT where
    fromEnum OtNameIdPredefinedTCopyright = 0
    fromEnum OtNameIdPredefinedTFontFamily = 1
    fromEnum OtNameIdPredefinedTFontSubfamily = 2
    fromEnum OtNameIdPredefinedTUniqueId = 3
    fromEnum OtNameIdPredefinedTFullName = 4
    fromEnum OtNameIdPredefinedTVersionString = 5
    fromEnum OtNameIdPredefinedTPostscriptName = 6
    fromEnum OtNameIdPredefinedTTrademark = 7
    fromEnum OtNameIdPredefinedTManufacturer = 8
    fromEnum OtNameIdPredefinedTDesigner = 9
    fromEnum OtNameIdPredefinedTDescription = 10
    fromEnum OtNameIdPredefinedTVendorUrl = 11
    fromEnum OtNameIdPredefinedTDesignerUrl = 12
    fromEnum OtNameIdPredefinedTLicense = 13
    fromEnum OtNameIdPredefinedTLicenseUrl = 14
    fromEnum OtNameIdPredefinedTTypographicFamily = 16
    fromEnum OtNameIdPredefinedTTypographicSubfamily = 17
    fromEnum OtNameIdPredefinedTMacFullName = 18
    fromEnum OtNameIdPredefinedTSampleText = 19
    fromEnum OtNameIdPredefinedTCidFindfontName = 20
    fromEnum OtNameIdPredefinedTWwsFamily = 21
    fromEnum OtNameIdPredefinedTWwsSubfamily = 22
    fromEnum OtNameIdPredefinedTLightBackground = 23
    fromEnum OtNameIdPredefinedTDarkBackground = 24
    fromEnum OtNameIdPredefinedTVariationsPsPrefix = 25
    fromEnum OtNameIdPredefinedTInvalid = 65535
    fromEnum (AnotherOtNameIdPredefinedT k) = k

    toEnum 0 = OtNameIdPredefinedTCopyright
    toEnum 1 = OtNameIdPredefinedTFontFamily
    toEnum 2 = OtNameIdPredefinedTFontSubfamily
    toEnum 3 = OtNameIdPredefinedTUniqueId
    toEnum 4 = OtNameIdPredefinedTFullName
    toEnum 5 = OtNameIdPredefinedTVersionString
    toEnum 6 = OtNameIdPredefinedTPostscriptName
    toEnum 7 = OtNameIdPredefinedTTrademark
    toEnum 8 = OtNameIdPredefinedTManufacturer
    toEnum 9 = OtNameIdPredefinedTDesigner
    toEnum 10 = OtNameIdPredefinedTDescription
    toEnum 11 = OtNameIdPredefinedTVendorUrl
    toEnum 12 = OtNameIdPredefinedTDesignerUrl
    toEnum 13 = OtNameIdPredefinedTLicense
    toEnum 14 = OtNameIdPredefinedTLicenseUrl
    toEnum 16 = OtNameIdPredefinedTTypographicFamily
    toEnum 17 = OtNameIdPredefinedTTypographicSubfamily
    toEnum 18 = OtNameIdPredefinedTMacFullName
    toEnum 19 = OtNameIdPredefinedTSampleText
    toEnum 20 = OtNameIdPredefinedTCidFindfontName
    toEnum 21 = OtNameIdPredefinedTWwsFamily
    toEnum 22 = OtNameIdPredefinedTWwsSubfamily
    toEnum 23 = OtNameIdPredefinedTLightBackground
    toEnum 24 = OtNameIdPredefinedTDarkBackground
    toEnum 25 = OtNameIdPredefinedTVariationsPsPrefix
    toEnum 65535 = OtNameIdPredefinedTInvalid
    toEnum k = AnotherOtNameIdPredefinedT k

instance P.Ord OtNameIdPredefinedT where
    compare a b = P.compare (P.fromEnum a) (P.fromEnum b)

-- Enum ot_math_kern_t
-- | The math kerning-table types defined for the four corners
-- of a glyph.
-- 
-- /Since: 1.3.3/
data OtMathKernT = 
      OtMathKernTTopRight
    -- ^ The top right corner of the glyph.
    | OtMathKernTTopLeft
    -- ^ The top left corner of the glyph.
    | OtMathKernTBottomRight
    -- ^ The bottom right corner of the glyph.
    | OtMathKernTBottomLeft
    -- ^ The bottom left corner of the glyph.
    | AnotherOtMathKernT Int
    -- ^ Catch-all for unknown values
    deriving (Show, Eq)

instance P.Enum OtMathKernT where
    fromEnum OtMathKernTTopRight = 0
    fromEnum OtMathKernTTopLeft = 1
    fromEnum OtMathKernTBottomRight = 2
    fromEnum OtMathKernTBottomLeft = 3
    fromEnum (AnotherOtMathKernT k) = k

    toEnum 0 = OtMathKernTTopRight
    toEnum 1 = OtMathKernTTopLeft
    toEnum 2 = OtMathKernTBottomRight
    toEnum 3 = OtMathKernTBottomLeft
    toEnum k = AnotherOtMathKernT k

instance P.Ord OtMathKernT where
    compare a b = P.compare (P.fromEnum a) (P.fromEnum b)

-- Enum ot_math_constant_t
-- | The \'MATH\' table constants, refer to
-- <https://docs.microsoft.com/en-us/typography/opentype/spec/math#mathconstants-table OpenType documentation>
-- For more explanations.
-- 
-- /Since: 1.3.3/
data OtMathConstantT = 
      OtMathConstantTScriptPercentScaleDown
    -- ^ scriptPercentScaleDown
    | OtMathConstantTScriptScriptPercentScaleDown
    -- ^ scriptScriptPercentScaleDown
    | OtMathConstantTDelimitedSubFormulaMinHeight
    -- ^ delimitedSubFormulaMinHeight
    | OtMathConstantTDisplayOperatorMinHeight
    -- ^ displayOperatorMinHeight
    | OtMathConstantTMathLeading
    -- ^ mathLeading
    | OtMathConstantTAxisHeight
    -- ^ axisHeight
    | OtMathConstantTAccentBaseHeight
    -- ^ accentBaseHeight
    | OtMathConstantTFlattenedAccentBaseHeight
    -- ^ flattenedAccentBaseHeight
    | OtMathConstantTSubscriptShiftDown
    -- ^ subscriptShiftDown
    | OtMathConstantTSubscriptTopMax
    -- ^ subscriptTopMax
    | OtMathConstantTSubscriptBaselineDropMin
    -- ^ subscriptBaselineDropMin
    | OtMathConstantTSuperscriptShiftUp
    -- ^ superscriptShiftUp
    | OtMathConstantTSuperscriptShiftUpCramped
    -- ^ superscriptShiftUpCramped
    | OtMathConstantTSuperscriptBottomMin
    -- ^ superscriptBottomMin
    | OtMathConstantTSuperscriptBaselineDropMax
    -- ^ superscriptBaselineDropMax
    | OtMathConstantTSubSuperscriptGapMin
    -- ^ subSuperscriptGapMin
    | OtMathConstantTSuperscriptBottomMaxWithSubscript
    -- ^ superscriptBottomMaxWithSubscript
    | OtMathConstantTSpaceAfterScript
    -- ^ spaceAfterScript
    | OtMathConstantTUpperLimitGapMin
    -- ^ upperLimitGapMin
    | OtMathConstantTUpperLimitBaselineRiseMin
    -- ^ upperLimitBaselineRiseMin
    | OtMathConstantTLowerLimitGapMin
    -- ^ lowerLimitGapMin
    | OtMathConstantTLowerLimitBaselineDropMin
    -- ^ lowerLimitBaselineDropMin
    | OtMathConstantTStackTopShiftUp
    -- ^ stackTopShiftUp
    | OtMathConstantTStackTopDisplayStyleShiftUp
    -- ^ stackTopDisplayStyleShiftUp
    | OtMathConstantTStackBottomShiftDown
    -- ^ stackBottomShiftDown
    | OtMathConstantTStackBottomDisplayStyleShiftDown
    -- ^ stackBottomDisplayStyleShiftDown
    | OtMathConstantTStackGapMin
    -- ^ stackGapMin
    | OtMathConstantTStackDisplayStyleGapMin
    -- ^ stackDisplayStyleGapMin
    | OtMathConstantTStretchStackTopShiftUp
    -- ^ stretchStackTopShiftUp
    | OtMathConstantTStretchStackBottomShiftDown
    -- ^ stretchStackBottomShiftDown
    | OtMathConstantTStretchStackGapAboveMin
    -- ^ stretchStackGapAboveMin
    | OtMathConstantTStretchStackGapBelowMin
    -- ^ stretchStackGapBelowMin
    | OtMathConstantTFractionNumeratorShiftUp
    -- ^ fractionNumeratorShiftUp
    | OtMathConstantTFractionNumeratorDisplayStyleShiftUp
    -- ^ fractionNumeratorDisplayStyleShiftUp
    | OtMathConstantTFractionDenominatorShiftDown
    -- ^ fractionDenominatorShiftDown
    | OtMathConstantTFractionDenominatorDisplayStyleShiftDown
    -- ^ fractionDenominatorDisplayStyleShiftDown
    | OtMathConstantTFractionNumeratorGapMin
    -- ^ fractionNumeratorGapMin
    | OtMathConstantTFractionNumDisplayStyleGapMin
    -- ^ fractionNumDisplayStyleGapMin
    | OtMathConstantTFractionRuleThickness
    -- ^ fractionRuleThickness
    | OtMathConstantTFractionDenominatorGapMin
    -- ^ fractionDenominatorGapMin
    | OtMathConstantTFractionDenomDisplayStyleGapMin
    -- ^ fractionDenomDisplayStyleGapMin
    | OtMathConstantTSkewedFractionHorizontalGap
    -- ^ skewedFractionHorizontalGap
    | OtMathConstantTSkewedFractionVerticalGap
    -- ^ skewedFractionVerticalGap
    | OtMathConstantTOverbarVerticalGap
    -- ^ overbarVerticalGap
    | OtMathConstantTOverbarRuleThickness
    -- ^ overbarRuleThickness
    | OtMathConstantTOverbarExtraAscender
    -- ^ overbarExtraAscender
    | OtMathConstantTUnderbarVerticalGap
    -- ^ underbarVerticalGap
    | OtMathConstantTUnderbarRuleThickness
    -- ^ underbarRuleThickness
    | OtMathConstantTUnderbarExtraDescender
    -- ^ underbarExtraDescender
    | OtMathConstantTRadicalVerticalGap
    -- ^ radicalVerticalGap
    | OtMathConstantTRadicalDisplayStyleVerticalGap
    -- ^ radicalDisplayStyleVerticalGap
    | OtMathConstantTRadicalRuleThickness
    -- ^ radicalRuleThickness
    | OtMathConstantTRadicalExtraAscender
    -- ^ radicalExtraAscender
    | OtMathConstantTRadicalKernBeforeDegree
    -- ^ radicalKernBeforeDegree
    | OtMathConstantTRadicalKernAfterDegree
    -- ^ radicalKernAfterDegree
    | OtMathConstantTRadicalDegreeBottomRaisePercent
    -- ^ radicalDegreeBottomRaisePercent
    | AnotherOtMathConstantT Int
    -- ^ Catch-all for unknown values
    deriving (Show, Eq)

instance P.Enum OtMathConstantT where
    fromEnum OtMathConstantTScriptPercentScaleDown = 0
    fromEnum OtMathConstantTScriptScriptPercentScaleDown = 1
    fromEnum OtMathConstantTDelimitedSubFormulaMinHeight = 2
    fromEnum OtMathConstantTDisplayOperatorMinHeight = 3
    fromEnum OtMathConstantTMathLeading = 4
    fromEnum OtMathConstantTAxisHeight = 5
    fromEnum OtMathConstantTAccentBaseHeight = 6
    fromEnum OtMathConstantTFlattenedAccentBaseHeight = 7
    fromEnum OtMathConstantTSubscriptShiftDown = 8
    fromEnum OtMathConstantTSubscriptTopMax = 9
    fromEnum OtMathConstantTSubscriptBaselineDropMin = 10
    fromEnum OtMathConstantTSuperscriptShiftUp = 11
    fromEnum OtMathConstantTSuperscriptShiftUpCramped = 12
    fromEnum OtMathConstantTSuperscriptBottomMin = 13
    fromEnum OtMathConstantTSuperscriptBaselineDropMax = 14
    fromEnum OtMathConstantTSubSuperscriptGapMin = 15
    fromEnum OtMathConstantTSuperscriptBottomMaxWithSubscript = 16
    fromEnum OtMathConstantTSpaceAfterScript = 17
    fromEnum OtMathConstantTUpperLimitGapMin = 18
    fromEnum OtMathConstantTUpperLimitBaselineRiseMin = 19
    fromEnum OtMathConstantTLowerLimitGapMin = 20
    fromEnum OtMathConstantTLowerLimitBaselineDropMin = 21
    fromEnum OtMathConstantTStackTopShiftUp = 22
    fromEnum OtMathConstantTStackTopDisplayStyleShiftUp = 23
    fromEnum OtMathConstantTStackBottomShiftDown = 24
    fromEnum OtMathConstantTStackBottomDisplayStyleShiftDown = 25
    fromEnum OtMathConstantTStackGapMin = 26
    fromEnum OtMathConstantTStackDisplayStyleGapMin = 27
    fromEnum OtMathConstantTStretchStackTopShiftUp = 28
    fromEnum OtMathConstantTStretchStackBottomShiftDown = 29
    fromEnum OtMathConstantTStretchStackGapAboveMin = 30
    fromEnum OtMathConstantTStretchStackGapBelowMin = 31
    fromEnum OtMathConstantTFractionNumeratorShiftUp = 32
    fromEnum OtMathConstantTFractionNumeratorDisplayStyleShiftUp = 33
    fromEnum OtMathConstantTFractionDenominatorShiftDown = 34
    fromEnum OtMathConstantTFractionDenominatorDisplayStyleShiftDown = 35
    fromEnum OtMathConstantTFractionNumeratorGapMin = 36
    fromEnum OtMathConstantTFractionNumDisplayStyleGapMin = 37
    fromEnum OtMathConstantTFractionRuleThickness = 38
    fromEnum OtMathConstantTFractionDenominatorGapMin = 39
    fromEnum OtMathConstantTFractionDenomDisplayStyleGapMin = 40
    fromEnum OtMathConstantTSkewedFractionHorizontalGap = 41
    fromEnum OtMathConstantTSkewedFractionVerticalGap = 42
    fromEnum OtMathConstantTOverbarVerticalGap = 43
    fromEnum OtMathConstantTOverbarRuleThickness = 44
    fromEnum OtMathConstantTOverbarExtraAscender = 45
    fromEnum OtMathConstantTUnderbarVerticalGap = 46
    fromEnum OtMathConstantTUnderbarRuleThickness = 47
    fromEnum OtMathConstantTUnderbarExtraDescender = 48
    fromEnum OtMathConstantTRadicalVerticalGap = 49
    fromEnum OtMathConstantTRadicalDisplayStyleVerticalGap = 50
    fromEnum OtMathConstantTRadicalRuleThickness = 51
    fromEnum OtMathConstantTRadicalExtraAscender = 52
    fromEnum OtMathConstantTRadicalKernBeforeDegree = 53
    fromEnum OtMathConstantTRadicalKernAfterDegree = 54
    fromEnum OtMathConstantTRadicalDegreeBottomRaisePercent = 55
    fromEnum (AnotherOtMathConstantT k) = k

    toEnum 0 = OtMathConstantTScriptPercentScaleDown
    toEnum 1 = OtMathConstantTScriptScriptPercentScaleDown
    toEnum 2 = OtMathConstantTDelimitedSubFormulaMinHeight
    toEnum 3 = OtMathConstantTDisplayOperatorMinHeight
    toEnum 4 = OtMathConstantTMathLeading
    toEnum 5 = OtMathConstantTAxisHeight
    toEnum 6 = OtMathConstantTAccentBaseHeight
    toEnum 7 = OtMathConstantTFlattenedAccentBaseHeight
    toEnum 8 = OtMathConstantTSubscriptShiftDown
    toEnum 9 = OtMathConstantTSubscriptTopMax
    toEnum 10 = OtMathConstantTSubscriptBaselineDropMin
    toEnum 11 = OtMathConstantTSuperscriptShiftUp
    toEnum 12 = OtMathConstantTSuperscriptShiftUpCramped
    toEnum 13 = OtMathConstantTSuperscriptBottomMin
    toEnum 14 = OtMathConstantTSuperscriptBaselineDropMax
    toEnum 15 = OtMathConstantTSubSuperscriptGapMin
    toEnum 16 = OtMathConstantTSuperscriptBottomMaxWithSubscript
    toEnum 17 = OtMathConstantTSpaceAfterScript
    toEnum 18 = OtMathConstantTUpperLimitGapMin
    toEnum 19 = OtMathConstantTUpperLimitBaselineRiseMin
    toEnum 20 = OtMathConstantTLowerLimitGapMin
    toEnum 21 = OtMathConstantTLowerLimitBaselineDropMin
    toEnum 22 = OtMathConstantTStackTopShiftUp
    toEnum 23 = OtMathConstantTStackTopDisplayStyleShiftUp
    toEnum 24 = OtMathConstantTStackBottomShiftDown
    toEnum 25 = OtMathConstantTStackBottomDisplayStyleShiftDown
    toEnum 26 = OtMathConstantTStackGapMin
    toEnum 27 = OtMathConstantTStackDisplayStyleGapMin
    toEnum 28 = OtMathConstantTStretchStackTopShiftUp
    toEnum 29 = OtMathConstantTStretchStackBottomShiftDown
    toEnum 30 = OtMathConstantTStretchStackGapAboveMin
    toEnum 31 = OtMathConstantTStretchStackGapBelowMin
    toEnum 32 = OtMathConstantTFractionNumeratorShiftUp
    toEnum 33 = OtMathConstantTFractionNumeratorDisplayStyleShiftUp
    toEnum 34 = OtMathConstantTFractionDenominatorShiftDown
    toEnum 35 = OtMathConstantTFractionDenominatorDisplayStyleShiftDown
    toEnum 36 = OtMathConstantTFractionNumeratorGapMin
    toEnum 37 = OtMathConstantTFractionNumDisplayStyleGapMin
    toEnum 38 = OtMathConstantTFractionRuleThickness
    toEnum 39 = OtMathConstantTFractionDenominatorGapMin
    toEnum 40 = OtMathConstantTFractionDenomDisplayStyleGapMin
    toEnum 41 = OtMathConstantTSkewedFractionHorizontalGap
    toEnum 42 = OtMathConstantTSkewedFractionVerticalGap
    toEnum 43 = OtMathConstantTOverbarVerticalGap
    toEnum 44 = OtMathConstantTOverbarRuleThickness
    toEnum 45 = OtMathConstantTOverbarExtraAscender
    toEnum 46 = OtMathConstantTUnderbarVerticalGap
    toEnum 47 = OtMathConstantTUnderbarRuleThickness
    toEnum 48 = OtMathConstantTUnderbarExtraDescender
    toEnum 49 = OtMathConstantTRadicalVerticalGap
    toEnum 50 = OtMathConstantTRadicalDisplayStyleVerticalGap
    toEnum 51 = OtMathConstantTRadicalRuleThickness
    toEnum 52 = OtMathConstantTRadicalExtraAscender
    toEnum 53 = OtMathConstantTRadicalKernBeforeDegree
    toEnum 54 = OtMathConstantTRadicalKernAfterDegree
    toEnum 55 = OtMathConstantTRadicalDegreeBottomRaisePercent
    toEnum k = AnotherOtMathConstantT k

instance P.Ord OtMathConstantT where
    compare a b = P.compare (P.fromEnum a) (P.fromEnum b)

-- Enum ot_layout_glyph_class_t
-- | The GDEF classes defined for glyphs.
data OtLayoutGlyphClassT = 
      OtLayoutGlyphClassTUnclassified
    -- ^ Glyphs not matching the other classifications
    | OtLayoutGlyphClassTBaseGlyph
    -- ^ Spacing, single characters, capable of accepting marks
    | OtLayoutGlyphClassTLigature
    -- ^ Glyphs that represent ligation of multiple characters
    | OtLayoutGlyphClassTMark
    -- ^ Non-spacing, combining glyphs that represent marks
    | OtLayoutGlyphClassTComponent
    -- ^ Spacing glyphs that represent part of a single character
    | AnotherOtLayoutGlyphClassT Int
    -- ^ Catch-all for unknown values
    deriving (Show, Eq)

instance P.Enum OtLayoutGlyphClassT where
    fromEnum OtLayoutGlyphClassTUnclassified = 0
    fromEnum OtLayoutGlyphClassTBaseGlyph = 1
    fromEnum OtLayoutGlyphClassTLigature = 2
    fromEnum OtLayoutGlyphClassTMark = 3
    fromEnum OtLayoutGlyphClassTComponent = 4
    fromEnum (AnotherOtLayoutGlyphClassT k) = k

    toEnum 0 = OtLayoutGlyphClassTUnclassified
    toEnum 1 = OtLayoutGlyphClassTBaseGlyph
    toEnum 2 = OtLayoutGlyphClassTLigature
    toEnum 3 = OtLayoutGlyphClassTMark
    toEnum 4 = OtLayoutGlyphClassTComponent
    toEnum k = AnotherOtLayoutGlyphClassT k

instance P.Ord OtLayoutGlyphClassT where
    compare a b = P.compare (P.fromEnum a) (P.fromEnum b)

-- Enum memory_mode_t
-- | Data type holding the memory modes available to
-- client programs.
-- 
-- Regarding these various memory-modes:
-- 
-- * In no case shall the HarfBuzz client modify memory
-- that is passed to HarfBuzz in a blob.  If there is
-- any such possibility, /@hBMEMORYMODEDUPLICATE@/ should be used
-- such that HarfBuzz makes a copy immediately,
-- * Use /@hBMEMORYMODEREADONLY@/ otherwise, unless you really really
-- really know what you are doing,
-- * /@hBMEMORYMODEWRITABLE@/ is appropriate if you really made a
-- copy of data solely for the purpose of passing to
-- HarfBuzz and doing that just once (no reuse!),
-- * If the font is @/mmap()/@ed, it\'s okay to use
-- /@hBMEMORYMODEREADONLYMAYMAKEWRITABLE@/, however, using that mode
-- correctly is very tricky.  Use /@hBMEMORYMODEREADONLY@/ instead.
data MemoryModeT = 
      MemoryModeTDuplicate
    -- ^ HarfBuzz immediately makes a copy of the data.
    | MemoryModeTReadonly
    -- ^ HarfBuzz client will never modify the data,
    --     and HarfBuzz will never modify the data.
    | MemoryModeTWritable
    -- ^ HarfBuzz client made a copy of the data solely
    --     for HarfBuzz, so HarfBuzz may modify the data.
    | MemoryModeTReadonlyMayMakeWritable
    -- ^ See above
    | AnotherMemoryModeT Int
    -- ^ Catch-all for unknown values
    deriving (Show, Eq)

instance P.Enum MemoryModeT where
    fromEnum MemoryModeTDuplicate = 0
    fromEnum MemoryModeTReadonly = 1
    fromEnum MemoryModeTWritable = 2
    fromEnum MemoryModeTReadonlyMayMakeWritable = 3
    fromEnum (AnotherMemoryModeT k) = k

    toEnum 0 = MemoryModeTDuplicate
    toEnum 1 = MemoryModeTReadonly
    toEnum 2 = MemoryModeTWritable
    toEnum 3 = MemoryModeTReadonlyMayMakeWritable
    toEnum k = AnotherMemoryModeT k

instance P.Ord MemoryModeT where
    compare a b = P.compare (P.fromEnum a) (P.fromEnum b)

-- Enum direction_t
-- | The direction of a text segment or buffer.
-- 
-- A segment can also be tested for horizontal or vertical
-- orientation (irrespective of specific direction) with
-- @/HB_DIRECTION_IS_HORIZONTAL()/@ or @/HB_DIRECTION_IS_VERTICAL()/@.
data DirectionT = 
      DirectionTInvalid
    -- ^ Initial, unset direction.
    | DirectionTLtr
    -- ^ Text is set horizontally from left to right.
    | DirectionTRtl
    -- ^ Text is set horizontally from right to left.
    | DirectionTTtb
    -- ^ Text is set vertically from top to bottom.
    | DirectionTBtt
    -- ^ Text is set vertically from bottom to top.
    | AnotherDirectionT Int
    -- ^ Catch-all for unknown values
    deriving (Show, Eq)

instance P.Enum DirectionT where
    fromEnum DirectionTInvalid = 0
    fromEnum DirectionTLtr = 4
    fromEnum DirectionTRtl = 5
    fromEnum DirectionTTtb = 6
    fromEnum DirectionTBtt = 7
    fromEnum (AnotherDirectionT k) = k

    toEnum 0 = DirectionTInvalid
    toEnum 4 = DirectionTLtr
    toEnum 5 = DirectionTRtl
    toEnum 6 = DirectionTTtb
    toEnum 7 = DirectionTBtt
    toEnum k = AnotherDirectionT k

instance P.Ord DirectionT where
    compare a b = P.compare (P.fromEnum a) (P.fromEnum b)

-- Enum buffer_content_type_t
-- | The type of t'GI.HarfBuzz.Structs.BufferT.BufferT' contents.
data BufferContentTypeT = 
      BufferContentTypeTInvalid
    -- ^ Initial value for new buffer.
    | BufferContentTypeTUnicode
    -- ^ The buffer contains input characters (before shaping).
    | BufferContentTypeTGlyphs
    -- ^ The buffer contains output glyphs (after shaping).
    | AnotherBufferContentTypeT Int
    -- ^ Catch-all for unknown values
    deriving (Show, Eq)

instance P.Enum BufferContentTypeT where
    fromEnum BufferContentTypeTInvalid = 0
    fromEnum BufferContentTypeTUnicode = 1
    fromEnum BufferContentTypeTGlyphs = 2
    fromEnum (AnotherBufferContentTypeT k) = k

    toEnum 0 = BufferContentTypeTInvalid
    toEnum 1 = BufferContentTypeTUnicode
    toEnum 2 = BufferContentTypeTGlyphs
    toEnum k = AnotherBufferContentTypeT k

instance P.Ord BufferContentTypeT where
    compare a b = P.compare (P.fromEnum a) (P.fromEnum b)

-- Enum buffer_cluster_level_t
-- | Data type for holding HarfBuzz\'s clustering behavior options. The cluster level
-- dictates one aspect of how HarfBuzz will treat non-base characters
-- during shaping.
-- 
-- In /@hBBUFFERCLUSTERLEVELMONOTONEGRAPHEMES@/, non-base
-- characters are merged into the cluster of the base character that precedes them.
-- There is also cluster merging every time the clusters will otherwise become non-monotone.
-- 
-- In /@hBBUFFERCLUSTERLEVELMONOTONECHARACTERS@/, non-base characters are initially
-- assigned their own cluster values, which are not merged into preceding base
-- clusters. This allows HarfBuzz to perform additional operations like reorder
-- sequences of adjacent marks. The output is still monotone, but the cluster
-- values are more granular.
-- 
-- In /@hBBUFFERCLUSTERLEVELCHARACTERS@/, non-base characters are assigned their
-- own cluster values, which are not merged into preceding base clusters. Moreover,
-- the cluster values are not merged into monotone order. This is the most granular
-- cluster level, and it is useful for clients that need to know the exact cluster
-- values of each character, but is harder to use for clients, since clusters
-- might appear in any order.
-- 
-- In /@hBBUFFERCLUSTERLEVELGRAPHEMES@/, non-base characters are merged into the
-- cluster of the base character that precedes them. This is similar to the Unicode
-- Grapheme Cluster algorithm, but it is not exactly the same. The output is
-- not forced to be monotone. This is useful for clients that want to use HarfBuzz
-- as a cheap implementation of the Unicode Grapheme Cluster algorithm.
-- 
-- /@hBBUFFERCLUSTERLEVELMONOTONEGRAPHEMES@/ is the default, because it maintains
-- backward compatibility with older versions of HarfBuzz. New client programs that
-- do not need to maintain such backward compatibility are recommended to use
-- /@hBBUFFERCLUSTERLEVELMONOTONECHARACTERS@/ instead of the default.
-- 
-- /Since: 0.9.42/
data BufferClusterLevelT = 
      BufferClusterLevelTMonotoneGraphemes
    -- ^ Return cluster values grouped by graphemes into
    --   monotone order.
    | BufferClusterLevelTMonotoneCharacters
    -- ^ Return cluster values grouped into monotone order.
    | BufferClusterLevelTCharacters
    -- ^ Don\'t group cluster values.
    | BufferClusterLevelTGraphemes
    -- ^ Only group clusters, but don\'t enforce monotone order.
    | BufferClusterLevelTDefault
    -- ^ Default cluster level,
    --   equal to /@hBBUFFERCLUSTERLEVELMONOTONEGRAPHEMES@/.
    | AnotherBufferClusterLevelT Int
    -- ^ Catch-all for unknown values
    deriving (Show, Eq)

instance P.Enum BufferClusterLevelT where
    fromEnum BufferClusterLevelTMonotoneGraphemes = 0
    fromEnum BufferClusterLevelTMonotoneCharacters = 1
    fromEnum BufferClusterLevelTCharacters = 2
    fromEnum BufferClusterLevelTGraphemes = 3
    fromEnum BufferClusterLevelTDefault = 0
    fromEnum (AnotherBufferClusterLevelT k) = k

    toEnum 0 = BufferClusterLevelTMonotoneGraphemes
    toEnum 1 = BufferClusterLevelTMonotoneCharacters
    toEnum 2 = BufferClusterLevelTCharacters
    toEnum 3 = BufferClusterLevelTGraphemes
    toEnum k = AnotherBufferClusterLevelT k

instance P.Ord BufferClusterLevelT where
    compare a b = P.compare (P.fromEnum a) (P.fromEnum b)


